Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
@@ -1662,441 +3093,59 @@
   inherited;
   case pgeProduct.TabIndex of
-  TI_ORDER :     begin
-                  memMessage.Visible := true;
+  TI_COMPONENT :     begin
                   memOrder.Visible := true;
                   cmdAccept.Visible := true;
                   pnlSelectedTests.Visible := true;
-                  pgeProduct.Height := 281;
+                  lvSelectionList.Width := lvSelectionList.Width + 1; //added to fix font resize issue - funky column display
                 end;
   TI_INFO :     begin
-                  if lvSelectionList.Items.Count > 0 then exit;
-                  LRORDERMODE := TORDER_MODE_INFO;
-                  memMessage.Visible := false;
-                  memOrder.Visible := false;
-                  cmdAccept.Visible := false;
-                  pnlSelectedTests.Visible := false;
-                  pgeProduct.Height := 411;
+                  if lvSelectionList.Items.Count > 0 then
+                  begin
+                    memOrder.Visible := true;
+                    cmdAccept.Visible := true;
+                    pnlSelectedTests.Visible := true;
+                  end
+                  else
+                  begin
+                    memOrder.Visible := false;
+                    cmdAccept.Visible := false;
+                    pnlSelectedTests.Visible := false;
+                  end;
                 end;
   TI_RESULTS :  begin
-                  if lvSelectionList.Items.Count > 0 then exit;
-                  memMessage.Visible := false;
-                  memOrder.Visible := false;
-                  cmdAccept.Visible := false;
-                  pnlSelectedTests.Visible := false;
-                  pgeProduct.Height := 411;
+                  if lvSelectionList.Items.Count > 0 then
+                  begin
+                    memOrder.Visible := true;
+                    cmdAccept.Visible := true;
+                    pnlSelectedTests.Visible := true;
+                  end
+                  else
+                  begin
+                    memOrder.Visible := false;
+                    cmdAccept.Visible := false;
+                    pnlSelectedTests.Visible := false;
+                  end;
                 end;
   end; {case}
 end;
 
-procedure TfrmODBBank.cboCollTypeChange(Sender: TObject);
-begin
-  if (ALabTest = nil) or Changing or (cboCollType.ItemID = '') then exit;
-  if (cboCollType.ItemID = 'I') and (not ALabTest.LabCanCollect) then
-    begin
-      InfoBox(TX_NO_IMMED, TX_NO_IMMED_CAP, MB_OK or MB_ICONWARNING);
-      cboCollType.ItemIndex := -1;
-      Exit;
-    end;
-  SetupCollTimes(cboCollType.ItemID);
-end;
-
-procedure TfrmODBBank.LoadModifiers(AComboBox:TORComboBox);
+procedure TfrmODBBank.cboCollTimeChange(Sender: TObject);
 var
-  i: integer;
-begin
-  with AComboBox do
-    begin
-      Clear;
-      for i := 0 to uModifierList.Count - 1 do
-           Items.Add(uModifierList[i]);
-    end;
-end;
-
-procedure TfrmODBBank.LoadUrgencies(AComboBox:TORComboBox);
-var
-  i: integer;
-begin
-  with AComboBox do
-    begin
-      Clear;
-      for i := 0 to uUrgencyList.Count - 1 do
-         if (piece(uUrgencyList[i],'^',2) = 'STAT') and (StatAllowed(Patient.DFN) = false) then
-           Continue
-         else
-           Items.Add(uUrgencyList[i]);
-    end;
-end;
-
-procedure TfrmODBBank.btnAddTestsClick(Sender: TObject);
-var
-  aList, aTests, aRaw: TStringList;
-  ListItem: TListItem;
-  aStr, aMsg: String;                  //add independent structures for components, Tests, and associated fields.
-  aCollType, aModifier, aPreparation, aSurgery, aCollTime, aTestYes, aSpecimen, aCollSave: String;
-  CurAdd, i, j, k, getTest, TestAdded, aMSBOS, aMSBOSContinue: Integer;
-  x, name, aTypeScreen: String;
-begin
-  if not ValidAdd then Exit;
-  aList := TStringList.Create;
-  aTests := TStringList.Create;
-  aRaw := TStringList.Create;
-  try
-    aCollType := '';
-    aModifier := '';
-    aPreparation := '';
-    aSurgery := '';
-    aCollTime := '';
-    aTestYes := '0';
-    aTypeScreen := '';
-    uGetTnS := 0;
-    aSpecimen := '';
-    ExtractTypeScreen(aList, uVBECList);
-    if aList.Count > 0 then aTypeScreen := aList[0];
-    aList.Clear;
-    ExtractSpecimen(aList, uVBECList);
-    if aList.Count > 0 then aSpecimen := aList[0];
-    if LRORDERMODE = TORDER_MODE_DIAG then aTestYes := '1';
-    if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
-    //if length(cboPreparation.ItemID) > 0 then aPreparation := cboPreparation.Items[cboPreparation.ItemIndex];
-    if length(cboSurgery.ItemID) > 0 then aSurgery := cboSurgery.Items[cboSurgery.ItemIndex];
-    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
-    if (LRORDERMODE = TORDER_MODE_DIAG) and (length(cboAvailTest.ItemID) > 0) then
-      begin
-        uTestSelected := true;
-        with lvSelectionList do
-          begin
-            ListItem := Items.Add;
-            ListItem.Caption := piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',2);
-            ListItem.SubItems.Add('');
-            if length(cboModifiers.ItemID) > 0 then ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex])
-              else ListItem.SubItems.Add('');
-            ListItem.SubItems.Add(piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1));
-            if piece(cboAvailTest.Items[cboAvailTest.ItemIndex],'^',1) = aTypeScreen then
-              begin
-                lblTNS.Caption := '';
-                lblTNS.Visible := false;
-              end;
-          end;
-        lblCollTime.Enabled := false;
-        calCollTime.Enabled := false;
-        cboCollTime.Enabled := false;
-        lblCollType.Enabled := false;
-        cboCollType.Enabled := false;
-        cboAvailTest.ItemIndex := -1;
-      end;
-    if (LRORDERMODE = TORDER_MODE_COMP) and (length(cboAvailComp.ItemID) > 0) then
-      begin
-        if Length(cboSurgery.ItemID) > 0 then
-          begin
-            aList.Clear;
-            ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgey
-            for i := 0 to aList.Count - 1 do
-              begin
-                if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
-                 and (StrToInt(piece(aList[i],'^',2)) = cboSurgery.ItemID) then
-                  begin
-                    aMSBOS := StrToInt(piece(aList[i],'^',4));
-                    if (aMSBOS > 0) and (StrToInt(tQuantity.Text) > aMSBOS) then
-                      begin
-                        with Application do
-                        begin
-                          NormalizeTopMosts;
-                          aMSBOSContinue :=
-                            MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
-                                       ') exceeds the maximum number of units (' + IntToStr(aMSBOS) +
-                                       ') for the ' + cboSurgery.text +
-                                       ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
-                                       PChar('Maximum Number of Units Exceeded'),
-                                       MB_YESNO);
-                          RestoreTopMosts;
-                        end;
-                        if aMSBOSContinue = 7 then
-                          begin
-                            ShowMessage(cboAvailComp.Text + ' has NOT been added to this request.');
-                            exit;
-                          end;
-                      end;
-                  end;
-              end;
-          end;
-        if SpecimenNeeded(aList, uVBECList, aLabTest.ItemID) then  //check to see if type and screen is needed
-          begin
-            uGetTnS := 1;
-            for i := 0 to lvSelectionList.Items.Count - 1 do
-              begin
-                if lvSelectionList.Items[i].SubItems[2] = aTypeScreen then
-                  begin
-                    uGetTnS := 0;
-                    uDfltUrgency := cboUrgency.ItemID;
-                    lblTNS.Caption := '';
-                    lblTNS.Visible := false;
-                    break;
-                  end;
-              end;
-          end;
-        aList.Clear;
-        ExtractSpecimens(aList, uVBECList);    //Get specimen values to pass back to Server
-        for i := 0 to aList.Count - 1 do
-          begin
-            if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
-              begin
-                aSpecimen := piece(aList[i],'^',2) + '^' + aSpecimen;
-                break;
-              end;
-          end;
-        uComponentSelected := true;
-        with lvSelectionList do
-          begin
-            ListItem := Items.Add;
-            ListItem.Caption := piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',2);
-            ListItem.SubItems.Add(tQuantity.Text);
-            if length(cboModifiers.ItemID) > 0 then ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex])
-              else ListItem.SubItems.Add('');
-            ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
-          end;
-        lblWanted.Enabled := false;
-        calWantTime.Enabled := false;
-        //lblPreparation.Enabled := false;
-        //cboPreparation.Enabled := false;
-        lblSurgery.Enabled := false;
-        cboSurgery.Enabled := false;
-        lblReason.Enabled := false;
-        tReason.Enabled := false;
-        chkConsent.Enabled := false;
-        cboAvailComp.ItemIndex := -1;
-      end;
-    if Sender <> Self then
-      Responses.Clear;       // Sender=Self when called from SELF
-    CurAdd := 1;
-    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen;  //aSpecimen has 2 pieces
-    uSelectedItems.Add(aStr);
-    for i := 0 to uSelectedItems.Count - 1 do
-      begin
-        name := lvSelectionList.Items[i].Caption;
-        x := uSelectedItems[i];
-        if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
-          begin
-            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), name);
-          end
-        else
-          begin
-            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), name);
-            if Length(piece(x,'^',3)) > 0 then Responses.Update('QTY', CurAdd, piece(x,'^',3), piece(x,'^',3));
-            if Length(piece(x,'^',4)) > 0 then Responses.Update('MODIFIER', CurAdd, piece(x,'^',4), aModifier);
-            if Length(piece(x,'^',5)) > 0 then Responses.Update('SPECSTS', CurAdd, pieces(x,'^',5,7), piece(x,'^',5));
-            if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
-          end;
-        Inc(CurAdd);
-        aList.Clear;
-        TestAdded := 0;
-        getTest := 0;
-        ExtractTests(aList, uVBECList);   //Get Results associated with ordered components
-        for j := 0 to aList.Count - 1 do
-          begin
-            if StrToInt(piece(aList[j],'^',1)) = aLabTest.ItemID then
-              begin
-                if uTestsForResults.Count < 1 then getTest := 1;
-                for k := 0 to uTestsForResults.Count - 1 do
-                  begin
-                    if piece(uTestsForResults[k],'^',1) = piece(aList[j],'^',3) then
-                      begin
-                        getTest := 0;
-                        break;
-                      end
-                    else getTest := 1;
-                  end;
-                if getTest = 1 then
-                  begin
-                    uTestsForResults.Add(piece(aList[j],'^',3));
-                    TestAdded := 1;
-                  end;
-              end;
-          end;
-        if TestAdded = 1 then
-          begin
-            edtResults.Clear;
-            aTests.Clear;
-            GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
-            QuickCopy(ATests,edtResults);
-            if edtResults.Lines.Count > 0 then TabResults.ImageIndex := 1;
-            uRaw.Clear;
-            GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
-          end;
-      end;
-    if LRORDERMODE = TORDER_MODE_DIAG then
-      begin
-        if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
-        with cboCollType do if Length(ItemID) > 0 then
-          begin
-            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-            FLastCollType := ItemID;
-          end;
-        if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
-        if Length(txtDiagComment.Text) > 0 then Responses.Update('COMMENT',1,txtDiagComment.Text,txtDiagComment.Text);
-        if cboCollType.ItemID = 'LC' then
-          begin
-            with cboCollTime do
-              if Length(ItemID) > 0 then
-                begin
-                  Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
-                  FLastLabCollTime := ItemID + U + Text;
-                end
-              else if Length(Text) > 0 then
-                begin
-                  Responses.Update('START', 1, ValidCollTime(Text), Text) ;
-                  FLastLabCollTime := ValidCollTime(Text);
-                end;
-          end
-        else
-          begin
-            with calCollTime do
-              if FMDateTime > 0 then
-                begin
-                  Responses.Update('START', 1, ValidCollTime(Text), Text);
-                  FLastColltime := ValidCollTime(Text);
-                end
-              else
-                begin
-                  Responses.Update('START', 1, '', '') ;
-                  FLastCollTime := '';
-                end;
-          end;
-      end;
-    if LRORDERMODE = TORDER_MODE_COMP then
-      begin
-        if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
-        if Length(txtDiagComment.Text) > 0 then Responses.Update('COMMENT',1,txtDiagComment.Text,txtDiagComment.Text);
-        if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
-        //if Length(cboPreparation.Text) > 0 then Responses.Update('XFUSION',1,cboPreparation.ItemID,cboPreparation.Text);
-        if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
-        if Length(tReason.Text) > 0 then Responses.Update('REASON',1,tReason.Text,tReason.Text);
-        if chkConsent.Checked = true then Responses.Update('YN',1,'1','Yes');
-      end;
-    memOrder.Text := Responses.OrderText;
-    CurAdd := 1;
-    if uRaw.Count > 0 then
-      for j := 0 to uRaw.Count - 1 do
+  CollType: string;
+const
+  TX_BAD_TIME         = ' is not a routine lab collection time.' ;
+  TX_BAD_TIME_CAP     = 'Invalid Time';
+begin
+  CollType := 'LC';
+  with cboCollTime do
+    begin
+      if ItemID = 'LO' then
         begin
-          if Length(uRaw[j]) > 0 then Responses.Update('RESULTS', CurAdd, uRaw[j], piece(uRaw[j],'^',1));
-          Inc(CurAdd);
+          ItemIndex := -1;
+          Text := GetFutureLabTime(FMToday);
         end;
-    tQuantity.Text := '0';
-    ALabTest := nil;
-  finally
-    aList.Free;
-    aTests.Free;
-    aRaw.Free;
-  end;
-  aMsg := '';
-  if UgetTnS = 1 then
-    begin
-      lblTNS.Caption := 'TYPE + SCREEN must be added to order';
-      lblTNS.Visible := true;
-      cboAvailTest.SelectByID(aTypeScreen);
-      cboAvailTestSelect(self);
-    end;
-  {if getTnS = 1 then
-    begin
-      for i := 1 to cboAvailTest.Items.Count - 1 do
-        begin
-          if piece(cboAvailTest.Items[i],'^',1) = aTypeScreen then
-            begin
-              if piece(aSpecimen,'^',1) = '1' then
-                begin
-                  cboCollTime.Text := calWantTime.Text;
-                  aCollSave := cboCollTime.Text + '^' + cboCollTime.ItemID + '^' + cboCollType.Text + '^' + cboCollType.ItemID;
-                  cboCollTime.Text := '';
-                  cboCollType.Text := '';
-                  uSpecimen := 1;
-                end;
-              cboModifiers.Text := '';
-              cboAvailTest.SelectByID(aTypeScreen);
-              cboAvailTestSelect(Self);
-              btnAddTestsClick(Self);
-              uSpecimen := 0;
-              cboCollTime.Text := piece(aCollSave,'^',1);
-              cboCollType.Text := piece(aCollSave,'^',3);
-              aCollSave := '';
-              break;
-            end;
-        end;
-      aMsg := 'An order for Type and Screen has been added to this request' + '.';
-    end;
-  if (getTns = 1) then
-    begin
-      if length(aMsg) > 0 then aMsg := aMsg + crlf + crlf;
-      ShowMessage(aMsg);
-    end;}
-  cboModifiers.Text := '';
-  edtResults.Height := 247;
-  edtInfo.Height := 247;
-end;
-
-procedure TfrmODBBank.FormDestroy(Sender: TObject);
-begin
-  inherited;
-  uSelectedItems.Free;
-  uVBECList.Free;
-  uTestsForResults.Free;
-  uUrgencyList.Free;
-  uModifierList.Free;
-  uRaw.Free;
-end;
-
-procedure TfrmODBBank.btnRemoveClick(Sender: TObject);
-var
-  i,j,curAdd: integer;
-  x, name, aModifier, aTypeScreen: string;
-  aList: TStringList;
-begin
-  inherited;
-  aList := TStringList.Create;
-  curAdd := 1;
-  aModifier := '';
-  aTypeScreen := '';
-  ExtractTypeScreen(aList, uVBECList);
-  if aList.Count > 0 then aTypeScreen := aList[0];
-  aList.Clear;
-  if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
-  with lvSelectionList do
-    begin
-      for i := lvSelectionList.Items.Count - 1 downto 0 do
-        begin
-          if lvSelectionList.Items[i].Selected = true then
-            for j := uSelectedItems.Count - 1 downto 0 do
-            if lvSelectionList.Items[i].SubItems[2] = piece(uSelectedItems[j],'^',2) then
-              begin
-                if lvSelectionList.Items[i].SubItems[2] = aTypeScreen then
-                  begin
-                    uGetTnS := 1;
-                    lblTNS.Caption := 'TYPE+SCREEN must be added to order';
-                    lblTNS.Visible := true;
-                  end;
-                uSelectedItems.Delete(j);
-                lvSelectionList.Items[i].Delete;
-                break;
-              end;
-        end;
-    end;
-  Responses.Clear;
-  for i := 0 to uSelectedItems.Count - 1 do
-    begin
-      name := lvSelectionList.Items[i].Caption;
-      x := uSelectedItems[i];
-      if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
-        begin
-          if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), name);
-        end
-      else
-        begin
-          if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), name);
-          if Length(piece(x,'^',3)) > 0 then Responses.Update('QTY', CurAdd, piece(x,'^',3), piece(x,'^',3));
-          if Length(piece(x,'^',4)) > 0 then Responses.Update('MODIFIER', CurAdd, piece(x,'^',4), aModifier);
-          if Length(piece(x,'^',5)) > 0 then Responses.Update('SPECSTS', CurAdd, pieces(x,'^',5,7), piece(x,'^',5));
-        end;
-      Inc(CurAdd);
-    end;
-  if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
-  if cboCollType.ItemID = 'LC' then
+    end;
+  cboCollType.SelectByID(CollType);
+  if uSelectedItems.Count > 0 then
     begin
       with cboCollTime do
